
#include "DSC.h"

int main(int argc, char **argv){
	
	StochasticLib1 rand_num_gen(time(0));
	float * noise = new float [2048];
	
	for(int i=0; i<2048; i++){
		noise[i] = 0; //rand_num_gen.Normal(0,0.1);	
	} 

	sensor sensor1(noise);

	for(int i=0; i<2048; i++){
		noise[i] = rand_num_gen.Normal(0,0.01);
	} 

	sensor sensor2(noise);

	print_to_file(sensor1.get_data(), "ecg_data1.txt", 2048);
	print_to_file(sensor2.get_data(), "ecg_data2.txt", 2048);

	float b = 0;
	cout << "Angi antall bit:" << endl;
	cin >> b;

	float A = *max_element(sensor1.get_data(), sensor1.get_data() + 2048);
		
	float * ecg_quantized = new float [2048];
	char ** q_enc = new char* [2048];
	
	quantizer q("gauss", b);
	q.set_levels(A);
	q.quantize(sensor1.get_data(), ecg_quantized, q_enc);

	float * rep1 = q.get_levels();

	print_to_file(q_enc, "q_enc.txt", 2048);
	print_to_file(ecg_quantized, "ecg_quantized.txt", 2048);
	
	A = *max_element(sensor2.get_data(), sensor2.get_data() + 2048);

	float * ecg_quantized2 = new float [2048];
	char ** q_enc2 = new char * [2048];
	
	q.set_levels(A);
	q.quantize(sensor2.get_data(), ecg_quantized2, q_enc2);

	float * rep2 = q.get_levels();
	
	print_to_file(q_enc2, "q_enc2.txt", 2048);
	print_to_file(ecg_quantized2, "ecg_quantized2.txt", 2048);
	
	print_to_file(rep1, "rep.txt", 128);


	M = 3;
	N = 7;

	H = mod2sparse_allocate(M,N);

	mod2sparse_insert(H,0,0);
	mod2sparse_insert(H,0,3);
	mod2sparse_insert(H,0,4);
	mod2sparse_insert(H,0,5);
	mod2sparse_insert(H,1,1);
	mod2sparse_insert(H,1,3);
	mod2sparse_insert(H,1,4);
	mod2sparse_insert(H,1,6);
	mod2sparse_insert(H,2,2);
	mod2sparse_insert(H,2,4);
	mod2sparse_insert(H,2,5);
	mod2sparse_insert(H,2,6);

	
/*	M = 5000;
	N = 10000;
	
	distrib * d = distrib_create("3");
	make_ldpc(2,Evenboth,d,1);
*/	
	FILE * f;
	f = fopen("H.txt","w");
	mod2sparse_print(f,H);

	int seed = 1;
	int bs = 7;
	int nb = 1000;
	
	rand_seed(10*seed+2);

	FILE * srcf = fopen("rand-src.txt","w");
	
	for (int i=0; i<nb; i++){ 
		for (int j=0; j<bs; j++){ 
			fprintf(srcf,"%d",rand_int(2));
		}
		fprintf(srcf,"\n");
	}
	
	fclose(srcf);
	
	char * sblk = new char [N];
	char * cblk = new char [M];
	
	FILE * encf = fopen("enc.txt","w");
	srcf = fopen("q_enc.txt", "r");

	char *** coset = new char ** [8];
	for (int i=0; i<8; i++){
		*(coset + i) = new char * [16];
		for (int j=0; j<16; j++){
			*(*(coset + i)+j) = new char [7];
		}
	}
	
	float ** coset_float;
	coset_float = new float *[8];
	for (int i=0; i<8; i++){
		*(coset_float + i) = new float [16];
	}
	
	
	for (int n=0; ; n++){
		
		if (blockio_read(srcf,sblk,N)==EOF) break;
		mod2sparse_mulvec(H,sblk,cblk);
		coset_put(coset, coset_float, rep1);
		blockio_write(encf,cblk,M);
	}		

	fclose(encf);

	char * dblk = new char [M];
	float * oblk = new float [2048];
	char ** oblk_bin = new char * [2048];
	for (int i=0; i<2048; i++){
		*(oblk_bin + i) = new char [7];
	}
	
	float * side = new float [2048];
	side = sensor2.get_data();
	
	encf = fopen("enc.txt", "r");
	
	for (int i=0; ; i++){
		
		if(blockio_read(encf,dblk,M)==EOF) break;

		if (dblk[0]==0 && dblk[1]==0 && dblk[2]==0){
			oblk[i] = coset_float_find(side[i],coset_float[0]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[0]);
		}	
		else if (dblk[0]==0 && dblk[1]==0 && dblk[2]==1){
			oblk[i] = coset_float_find(side[i],coset_float[1]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[1]);
		}
		else if (dblk[0]==0 && dblk[1]==1 && dblk[2]==0){
			oblk[i] = coset_float_find(side[i],coset_float[2]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[2]);
		}
		else if (dblk[0]==0 && dblk[1]==1 && dblk[2]==1){
			oblk[i] = coset_float_find(side[i],coset_float[3]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[3]);
		}
		else if (dblk[0]==1 && dblk[1]==0 && dblk[2]==0){
			oblk[i] = coset_float_find(side[i],coset_float[4]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[4]);
		}
		else if (dblk[0]==1 && dblk[1]==0 && dblk[2]==1){
			oblk[i] = coset_float_find(side[i],coset_float[5]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[5]);
		}
		else if (dblk[0]==1 && dblk[1]==1 && dblk[2]==0){
			oblk[i] = coset_float_find(side[i],coset_float[6]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[6]);
		}
		else if (dblk[0]==1 && dblk[1]==1 && dblk[2]==1){
			oblk[i] = coset_float_find(side[i],coset_float[7]);
			oblk_bin[i] = coset_find(q_enc2[i], coset[7]);
		}
	}
	
	print_to_file(oblk, "output.txt", 2048);
	print_to_file(oblk_bin, "output_bin.txt", 2048);



	delete[] q_enc;
	delete[] q_enc2;
	delete[] ecg_quantized;
	delete[] ecg_quantized2;
	delete[] noise;
	delete[] coset;
	
}

template <class T>
void print_vector(T v){
	
	for(unsigned int i=0; i<v.size(); i++){
	
		cout << v[i];
	}
	mellomrom();

}

template <class T>
void print_to_file(T * a, char * f, int l){
	
	ofstream print_file;
	print_file.open(f);
	
	for(int i=0; i<l; i++){
		print_file << a[i] << endl;
	}
	
	print_file.close();
			
}

/* CREATE A SPARSE PARITY-CHECK MATRIX.  Of size M by N, stored in H. */
/* seed - Random number seed */
/* make_method - How to make it */
/* d - Distribution list specified */
/* no4cycle - Eliminate cycles of length four? */

void make_ldpc(int seed, make_method method, distrib *d, int no4cycle){
	
	mod2entry *e, *f, *g, *h;
	int added, uneven, elim4, all_even, n_full, left;
	int i, j, k, t, z, cb_N;
	int *part, *u;
	
	rand_seed(10*seed+1);
	
	H = mod2sparse_allocate(M,N);
	part = column_partition(d,N);
	
	/* Create the initial version of the parity check matrix. */
	
	switch (method){
		
		case Evencol:
			z = 0;
			left = part[z];
			
			for (j = 0; j<N; j++){ 
				while (left==0){ 
					z += 1;
					if (z>distrib_size(d)){ 
						abort();
					}
					
					left = part[z];
				}
				for (k = 0; k<distrib_num(d,z); k++){ 
					do{ 
						i = rand_int(M);
					}
					while (mod2sparse_find(H,i,j));
					
					mod2sparse_insert(H,i,j);
				}
				
				left -= 1;
			}
			
			break;
			
		case Evenboth:
			
			cb_N = 0;
			for (z = 0; z<distrib_size(d); z++){ 
				cb_N += distrib_num(d,z) * part[z];
			}
			u = (int*)chk_alloc (cb_N, sizeof *u);
			
			for (k = cb_N-1; k>=0; k--){ 
				u[k] = k%M;
			}
			
			uneven = 0;
			t = 0;
			z = 0;
			left = part[z];
			
			for (j = 0; j<N; j++){
				while (left==0){ 
					z += 1;
					if (z>distrib_size(d)){ 
						abort();
					}
					left = part[z];
				}
				
				for (k = 0; k<distrib_num(d,z); k++){
					for (i = t; i<cb_N && mod2sparse_find(H,u[i],j); i++);
					
					if (i==cb_N){ 
						uneven += 1;
						do{ 
							i = rand_int(M);
						}
						while (mod2sparse_find(H,i,j));
						
						mod2sparse_insert(H,i,j);
					}
					else{ 
						do{ 
							i = t + rand_int(cb_N-t);
						}
						while (mod2sparse_find(H,u[i],j));
						
						mod2sparse_insert(H,u[i],j);
						u[i] = u[t];
						t += 1;
					}
				}
				left -= 1;
			}
			if (uneven>0){ 
				fprintf(stderr,"Had to place %d checks in rows unevenly\n",uneven);
			}
			break;
		default: abort();
	}
	
	/* Add extra bits to avoid rows with less than two checks. */
	
	added = 0;
	
	for (i = 0; i<M; i++){ 
		e = mod2sparse_first_in_row(H,i);
    if (mod2sparse_at_end(e))
    { j = rand_int(N);
      e = mod2sparse_insert(H,i,j);
      added += 1;
    }
    e = mod2sparse_first_in_row(H,i);
    if (mod2sparse_at_end(mod2sparse_next_in_row(e)) && N>1)
    { do 
      { j = rand_int(N); 
      } while (j==mod2sparse_col(e));
      mod2sparse_insert(H,i,j);
      added += 1;
    }
  }

  if (added>0)
  { fprintf(stderr,
           "Added %d extra bit-checks to make row counts at least two\n",
           added);
  }

  /* Add extra bits to try to avoid problems with even column counts. */

  n_full = 0;
  all_even = 1;
  for (z = 0; z<distrib_size(d); z++)
  { if (distrib_num(d,z)==M) 
    { n_full += part[z];
    }
    if (distrib_num(d,z)%2==1)
    { all_even = 0;
    }
  }

  if (all_even && N-n_full>1 && added<2)
  { int a;
    for (a = 0; added+a<2; a++)
    { do
      { i = rand_int(M);
        j = rand_int(N);
      } while (mod2sparse_find(H,i,j));
      mod2sparse_insert(H,i,j);
    }
    fprintf(stderr,
 "Added %d extra bit-checks to try to avoid problems from even column counts\n",
      a);
  }

  /* Eliminate cycles of length four, if asked, and if possible. */

  if (no4cycle)
  { 
    elim4 = 0;

    for (t = 0; t<10; t++) 
    { k = 0;
      for (j = 0; j<N; j++)
      { for (e = mod2sparse_first_in_col(H,j);
             !mod2sparse_at_end(e);
             e = mod2sparse_next_in_col(e))
        { for (f = mod2sparse_first_in_row(H,mod2sparse_row(e));
               !mod2sparse_at_end(f);
               f = mod2sparse_next_in_row(f))
          { if (f==e) continue;
            for (g = mod2sparse_first_in_col(H,mod2sparse_col(f));
                 !mod2sparse_at_end(g);
                 g = mod2sparse_next_in_col(g))
            { if (g==f) continue;
              for (h = mod2sparse_first_in_row(H,mod2sparse_row(g));
                   !mod2sparse_at_end(h);
                   h = mod2sparse_next_in_row(h))
              { if (mod2sparse_col(h)==j)
                { do
                  { i = rand_int(M);
                  } while (mod2sparse_find(H,i,j));
                  mod2sparse_delete(H,e);
                  mod2sparse_insert(H,i,j);
                  elim4 += 1;
                  k += 1;
                  goto nextj;
                }
              }
            }
          }
        }
      nextj: ;
      }
      if (k==0) break;
    }

    if (elim4>0)
    { fprintf(stderr,
        "Eliminated %d cycles of length four by moving checks within column\n",
         elim4);
    }

    if (t==10) 
    { fprintf(stderr,
        "Couldn't eliminate all cycles of length four in 10 passes\n");
    }
  }
}


/* PARTITION THE COLUMNS ACCORDING TO THE SPECIFIED PROPORTIONS.  It
   may not be possible to do this exactly.  Returns a pointer to an
   array of integers containing the numbers of columns corresponding 
   to the entries in the distribution passed. */
/* d - List of proportions and number of check-bits */
/* n - Total number of columns to partition */

int *column_partition(distrib *d, int n){
	
	double *trunc;
	int *part;
	int cur, used;
	int i, j;
	
	trunc = (double*)chk_alloc (distrib_size(d), sizeof(double));
	part = (int*)chk_alloc (distrib_size(d), sizeof(int));
	
	used = 0;
	
	for (i = 0; i<distrib_size(d); i++){ 
		cur = (int)floor(distrib_prop(d,i)*n);
		part[i] = cur;
		trunc[i] = distrib_prop(d,i)*n - cur;
		used += cur;
	}
	if (used>n){ 
		abort();
	}
	
	while (used<n){ 
		cur = 0;
		for (j = 1; j<distrib_size(d); j++){ 
			if (trunc[j]>trunc[cur]){ 
				cur = j;
			}
		}
		part[cur] += 1;
		used += 1;
		trunc[cur] = -1;
	}
	
	free(trunc);
	return part;
}
