
#include "DSC.h"


quantizer::quantizer(string t, float b){

	bits = (int)b;
	l = (int)pow(2,b);
	type = t;
	
}

quantizer::~quantizer(){
	
	delete[] dec;
	delete[] rep;

}


void quantizer::set_levels(float A){

	float * d = new float [l+1];
	for(int i=0; i<l+1; i++) d[i]=0;
	float * r = new float [l];
	for(int i=0; i<l; i++) r[i]=0;

	
	const double eps = pow(10,-2.0);

	
	if(type=="uniform"){	
		for(int i=0; i<l+1; i++){
			d[i] = -A+(i*((2*A)/l));
		}
		
		for(int i=0; i<l; i++){
			r[i] = 0.5*(d[i+1]+d[i]);
		}
	}

	else if(type=="gauss"){

		for(int i=0; i<l+1; i++){
			d[i] = -A+(i*((2*A)/l));
		}

		for (int i = 0; i<l; i++){
 	  		r[i]=0.5*(d[i+1]+d[i]);
 	   	}

		for(int j=0; j<100; j++){

			for(int i=1; i<l; i++){
				
				d[i] = 0.5*(r[i] + r[i-1]);
			}

			for(int i=0; i<l; i++){
				set_function("gauss");
				double gauss = integralsimps(d[i],d[i+1],eps);
				set_function("gaussx");
				double gaussx = integralsimps(d[i],d[i+1],eps);
	
	       		r[i] = gaussx/gauss;
			}
		}    
	}
	
	else{
		cout << "Feil valg av kvantiserer, velg 'uniform' eller 'gauss'" << endl;
		exit(1);
	}
	
	
	this->dec = d;
	this->rep = r;

 
}

void quantizer::quantize(float * in, float * out, char ** bin_out){

	float * f = new float[l];
	
	for(int i=0; i<2048; i++){
		for(int j=0; j<l; j++){
			
			f[j] = abs(in[i]-rep[j]); 
		}

		int smallest = 0;
		for(int j=1; j<l; j++){
			if (f[j]<f[smallest]){
				smallest = j;
			}
		}
		out[i] = rep[smallest];

	
	}

	bin_enc(out, bin_out, rep, bits);

		
    delete[] f; 

}

string quantizer::get_type(){
	
	return type;	
}

