/***********************************************************************
This code is generated by the AlgoPascal translator

This code is distributed under the ALGLIB license
    (see http://www.alglib.net/copyrules.php for details)
***********************************************************************/

#include "DSC.h"
#include "ap.h"

/*-----------------------------------------------
This routines must be defined by the programmer:

double f(double x);

double integralsimps(const double& a, const double& b, const double& epsilon);
-----------------------------------------------*/

/*************************************************************************
Integration using the Simpson method with accuracy estimation.

The integral of function F over [a,b] is calculated with the
accuracy of order Epsilon.
*************************************************************************/

using namespace ap;

string function;

double integralsimps(const double a, const double b, const double epsilon)
{
    double result;
    double h;
    double s;
    double s1;
    double s2;
    double s3;
    double x;

    s2 = 1;
    h = b-a;
    s = f(a)+f(b);

    do{
        s3 = s2;
        h = h/2;
        s1 = 0;
        x = a+h;

        do{
            s1 = s1+2*f(x);
            x = x+2*h;

        }
        while(x<b);
        s = s+s1;
        s2 = (s+s1)*h/3;
        x = fabs(s3-s2)/15;
    }
    while(x>epsilon);
    result = s2;

    return result;
}

double f(double x){
	
	double s;
	if (function == "gauss"){
		
		int sigma = 1;
		s = 1 /(sqrt(2*pi())*sigma)*exp(-pow(x,2)/(sqr(2*sigma)));
	
	}
	else if (function == "gaussx"){
		int sigma = 1;
		s = x *(1/(sqrt(2*pi())*sigma)*exp(-pow(x,2)/(sqr(2*sigma))));
	}
	
	return s;	
}

void set_function(string f){
	
	if (f == "gauss"){function = "gauss";}
	else if (f == "gaussx"){function = "gaussx";}	
	
}

string get_function(){return function;}
